'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _GinPlatformUnauthorizedError = require('../errors/GinPlatformUnauthorizedError');

var _GinPlatformUnauthorizedError2 = _interopRequireDefault(_GinPlatformUnauthorizedError);

var _GinPlatformForbiddenError = require('../errors/GinPlatformForbiddenError');

var _GinPlatformForbiddenError2 = _interopRequireDefault(_GinPlatformForbiddenError);

var _nodeFetch = require('node-fetch');

var _nodeFetch2 = _interopRequireDefault(_nodeFetch);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var apiUrl = process.env.GIN_PLATFORM_API_URL || 'https://api.ginplatform.io';

var handleError = function handleError(response) {
    if (response.status >= 200 && response.status < 400) {
        return response.json();
    } else if (response.status === 401) {
        throw new _GinPlatformUnauthorizedError2.default('Unauthorized!');
    } else if (response.status === 403) {
        throw new _GinPlatformForbiddenError2.default('Forbidden');
    } else {
        throw new Error('A technical error occurred');
    }
};

var GinPlatformClient = function () {
    function GinPlatformClient(options) {
        _classCallCheck(this, GinPlatformClient);

        this.apiKey = options.apiKey;
    }

    _createClass(GinPlatformClient, [{
        key: 'request',
        value: function request(endpoint, method, data) {
            var options = {
                method: method || 'GET',
                headers: {
                    'Content-Type': 'application/json',
                    'Authorization': 'Bearer ' + this.apiKey
                }
            };

            if (data) {
                options.body = JSON.stringify(data);
            }

            return (0, _nodeFetch2.default)(apiUrl + endpoint).then(handleError);
        }
    }]);

    return GinPlatformClient;
}();

exports.default = GinPlatformClient;